;***********************************************************************
;*                                                                     *
;*                 Dieses Programm wurde maschinell erstellt           *
;*                                                                     *
;*                                                                     *
;***********************************************************************

                   #pragma AVRPART MEMORY PROG_FLASH 262144
                   #pragma AVRPART MEMORY EEPROM 4096
                   #pragma AVRPART MEMORY INT_SRAM SIZE 8192
                   #pragma AVRPART MEMORY INT_SRAM START_ADDR $200


                   .include "D:\PROGRAMME\Atmel\AVR Tools\AvrAssembler2\Appnotes\m2560def.inc"

.equ               _debug = 0                    ; No Debugmode
.equ               _uart  = 0                    ; UART0
.equ               _dbaud = 9600                 ; Baudrate
.equ               _clock = 16000000             ; Clock

                   .dseg

                   .eseg

                   .cseg

                   .org $0000

                   jmp RESET                     ; Reset
                   jmp EXT_INT0                  ; IRQ0 Request
                   jmp EXT_INT1                  ; IRQ1 Request
                   jmp EXT_INT2                  ; IRQ2 Request
                   jmp EXT_INT3                  ; IRQ3 Request
                   jmp EXT_INT4                  ; IRQ4 Request
                   jmp EXT_INT5                  ; IRQ5 Request
                   jmp EXT_INT6                  ; IRQ6 Request
                   jmp EXT_INT7                  ; IRQ7 Request
                   jmp PC_INT0                   ; Pin Change Interrupt Request 0
                   jmp PC_INT1                   ; Pin Change Interrupt Request 1
                   jmp PC_INT2                   ; Pin Change Interrupt Request 2
                   jmp WDT                       ; Watchdog Time-out Interrupt
                   jmp TIMER2_COMPA              ; Timer2 CompareA
                   jmp TIMER2_COMPB              ; Timer2 CompareB
                   jmp TIMER2_OVF                ; Timer2 Overflow
                   jmp TIMER1_CAPT               ; Timer1 Capture
                   jmp TIMER1_COMPA              ; Timer1 CompareA
                   jmp TIMER1_COMPB              ; Timer1 CompareB
                   jmp TIMER1_COMPC              ; Timer1 CompareC
                   jmp TIMER1_OVF                ; Timer1 Overflow
                   jmp TIMER0_COMPA              ; Timer0 CompareA
                   jmp TIMER0_COMPB              ; Timer0 CompareB
                   jmp TIMER0_OVF                ; Timer0 Overflow
                   jmp SPI_STC                   ; SPI Serial Transfer Complete
                   jmp USART0_RXC                ; USART0, Rx Complete
                   jmp USART0_UDRE               ; USART0 Data register Empty
                   jmp USART0_TXC                ; USART0, Tx Complete
                   jmp ANALOG_COMP               ; Analog Comparator
                   jmp ADC_COMP                  ; ADC Conversion Complete
                   jmp EE_READY                  ; EEPROM Ready
                   jmp TIMER3_CAPT               ; Timer3 Capture
                   jmp TIMER3_COMPA              ; Timer3 CompareA
                   jmp TIMER3_COMPB              ; Timer3 CompareB
                   jmp TIMER3_COMPC              ; Timer3 CompareC
                   jmp TIMER3_OVF                ; Timer3 Overflow
                   jmp USART1_RXC                ; USART1, Rx Complete
                   jmp USART1_UDRE               ; USART1 Data register Empty
                   jmp USART1_TXC                ; USART1, Tx Complete
                   jmp TWI                       ; 2-wire Serial Interface
                   jmp SPM_READY                 ; Store Program Memory Read
                   jmp TIMER4_CAPT               ; Timer4 Capture
                   jmp TIMER4_COMPA              ; Timer4 CompareA
                   jmp TIMER4_COMPB              ; Timer4 CompareB
                   jmp TIMER4_COMPC              ; Timer4 CompareC
                   jmp TIMER4_OVF                ; Timer4 Overflow
                   jmp TIMER5_CAPT               ; Timer5 Capture
                   jmp TIMER5_COMPA              ; Timer5 CompareA
                   jmp TIMER5_COMPB              ; Timer5 CompareB
                   jmp TIMER5_COMPC              ; Timer5 CompareC
                   jmp TIMER5_OVF                ; Timer5 Overflow
                   jmp USART2_RXC                ; USART2, Rx Complete
                   jmp USART2_UDRE               ; USART2 Data register Empty
                   jmp USART2_TXC                ; USART2, Tx Complete
                   jmp USART3_RXC                ; USART3, Rx Complete
                   jmp USART3_UDRE               ; USART3 Data register Empty
                   jmp USART3_TXC                ; USART3, Tx Complete

RESET:             ldi r16,high(RAMEND)
                   out SPH,r16
                   ldi r16,Low(RAMEND)
                   out SPL,r16

                   ;***************** PORTA ********************
                   ldi r16,$00
                   out DDRA,r16

                   ldi r16,$00
                   out PORTA,r16

                   ;***************** PORTB ********************
                   ldi r16,$00
                   out DDRB,r16

                   ldi r16,$00
                   out PORTB,r16

                   ;***************** PORTC ********************
                   ldi r16,$00
                   out DDRC,r16

                   ldi r16,$00
                   out PORTC,r16

                   ;***************** PORTD ********************
                   ldi r16,$00
                   out DDRD,r16

                   ldi r16,$00
                   out PORTD,r16

                   ;***************** PORTE ********************
                   ldi r16,$00
                   out DDRE,r16

                   ldi r16,$00
                   out PORTE,r16

                   ;***************** PORTF ********************
                   ldi r16,$00
                   out DDRF,r16

                   ldi r16,$00
                   out PORTF,r16

                   ;***************** PORTG ********************
                   ldi r16,$00
                   out DDRG,r16

                   ldi r16,$00
                   out PORTG,r16

                   ;***************** PORTH ********************
                   ldi r16,$00
                   sts DDRH,r16

                   ldi r16,$00
                   sts PORTH,r16

                   ;***************** PORTJ ********************
                   ldi r16,$00
                   sts DDRJ,r16

                   ldi r16,$00
                   sts PORTJ,r16

                   ;***************** PORTK ********************
                   ldi r16,$00
                   sts DDRK,r16

                   ldi r16,$00
                   sts PORTK,r16

                   ;***************** PORTL ********************
                   ldi r16,$00
                   sts DDRL,r16

                   ldi r16,$00
                   sts PORTL,r16

                   ;**************** USART0 ********************
                   ldi r16,$00                   ;TXC0,U2X0,MPCM0
                   sts UCSR0A,r16

                   ldi r16,$00                   ;RXCIE0,TXCIE0,UDRIE0,RXEN0,TXEN0,UCSZ02,TXB80
                   sts UCSR0B,r16

                   ldi r16,$00                   ;UMSEL01,UMSEL00,UPM01,UPM00,USBS0,UCSZ01,UCSZ00,UCPOL0
                   sts UCSR0C,r16

                   ldi r16,$00                   ;
                   sts UBRR0H,r16

                   ldi r16,$00                   ;
                   sts UBRR0L,r16

                   ;**************** USART1 ********************
                   ldi r16,$00                   ;TXC1,U2X1,MPCM1
                   sts UCSR1A,r16

                   ldi r16,$00                   ;RXCIE1,TXCIE1,UDRIE1,RXEN1,TXEN1,UCSZ12,TXB81
                   sts UCSR1B,r16

                   ldi r16,$00                   ;UMSEL11,UMSEL10,UPM11,UPM10,USBS1,UCSZ11,UCSZ10,UCPOL1
                   sts UCSR1C,r16

                   ldi r16,$00                   ;
                   sts UBRR1H,r16

                   ldi r16,$00                   ;
                   sts UBRR1L,r16

                   ;**************** USART2 ********************
                   ldi r16,$00                   ;TXC2,U2X2,MPCM2
                   sts UCSR2A,r16

                   ldi r16,$00                   ;RXCIE2,TXCIE2,UDRIE2,RXEN2,TXEN2,UCSZ22,TXB82
                   sts UCSR2B,r16

                   ldi r16,$00                   ;UMSEL21,UMSEL20,UPM21,UPM20,USBS2,UCSZ21,UCSZ20,UCPOL2
                   sts UCSR2C,r16

                   ldi r16,$00                   ;
                   sts UBRR2H,r16

                   ldi r16,$00                   ;
                   sts UBRR2L,r16

                   ;**************** USART3 ********************
                   ldi r16,$00                   ;TXC3,U2X3,MPCM3
                   sts UCSR3A,r16

                   ldi r16,$00                   ;RXCIE3,TXCIE3,UDRIE3,RXEN3,TXEN3,UCSZ32,TXB83
                   sts UCSR3B,r16

                   ldi r16,$00                   ;UMSEL31,UMSEL30,UPM31,UPM30,USBS3,UCSZ31,UCSZ30,UCPOL3
                   sts UCSR3C,r16

                   ldi r16,$00                   ;
                   sts UBRR3H,r16

                   ldi r16,$00                   ;
                   sts UBRR3L,r16

                   ;****************** TWI *********************
                   ldi r16,$00                   ;TWAM6,TWAM5,TWAM4,TWAM3,TWAM2,TWAM1,TWAM0
                   sts TWAMR,r16

                   ldi r16,$00                   ;TWBR7,TWBR6,TWBR5,TWBR4,TWBR3,TWBR2,TWBR1,TWBR0
                   sts TWBR,r16

                   ldi r16,$00                   ;TWINT,TWEA,TWSTA,TWSTO,TWWC,TWEN,TWIE
                   sts TWCR,r16

                   ldi r16,$00                   ;TWS7,TWS6,TWS5,TWS4,TWS3,TWPS1,TWPS0
                   sts TWSR,r16

                   ldi r16,$00                   ;TWA6,TWA5,TWA4,TWA3,TWA2,TWA1,TWA0,TWGCE
                   sts TWAR,r16

                   ;****************** SPI *********************
                   ldi r16,$00                   ;SPI2X
                   out SPSR,r16

                   ldi r16,$00                   ;SPIE,SPE,DORD,MSTR,CPOL,CPHA,SPR1,SPR0
                   out SPCR,r16

                   ;************ TIMER_COUNTER_0 ***************
                   ldi r16,$00                   ;OCIE0B,OCIE0A,TOIE0
                   sts TIMSK0,r16

                   ldi r16,$00                   ;COM0A1,COM0A0,COM0B1,COM0B0,WGM01,WGM00
                   out TCCR0A,r16

                   ldi r16,$00                   ;FOC0A,FOC0B,WGM02,CS02,CS01,CS00
                   out TCCR0B,r16

                   ldi r16,$00                   ;
                   out OCR0A,r16

                   ldi r16,$00                   ;
                   out OCR0B,r16

                   ldi r16,$00                   ;TSM,PSRSYNCTSM,PSRASY
                   out GTCCR,r16

                   ;************ TIMER_COUNTER_1 ***************
                   ldi r16,$00                   ;ICIE1,OCIE1A,TOIE1
                   sts TIMSK1,r16

                   ldi r16,$00                   ;COM1A1,COM1A0,COM1B1,COM1B0,COM1C1,COM1C0,WGM11,WGM10
                   sts TCCR1A,r16

                   ldi r16,$00                   ;ICNC1,ICES1,WGM13,WGM12,CS12,CS11,CS10
                   sts TCCR1B,r16

                   ldi r16,$00                   ;FOC1A,FOC1B,FOC1C
                   sts TCCR1C,r16

                   ldi r16,High($0000)           ;
                   sts OCR1AH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR1AL,r16

                   ldi r16,High($0000)           ;
                   sts OCR1BH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR1BL,r16

                   ldi r16,High($0000)           ;
                   sts ICR1H,r16

                   ldi r16,Low($0000)            ;
                   sts ICR1L,r16

                   ldi r16,High($0000)           ;
                   sts OCR1CH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR1CL,r16

                   ;************ TIMER_COUNTER_2 ***************
                   ldi r16,$00                   ;OCIE2B,OCIE2A,TOIE2
                   sts TIMSK2,r16

                   ldi r16,$00                   ;COM2A1,COM2A0,COM2B1,COM2B0,WGM21,WGM20
                   sts TCCR2A,r16

                   ldi r16,$00                   ;FOC2A,FOC2B,WGM22,CS22,CS21,CS20
                   sts TCCR2B,r16

                   ldi r16,$00                   ;
                   sts OCR2A,r16

                   ldi r16,$00                   ;
                   sts OCR2B,r16

                   ldi r16,$00                   ;EXCLK,AS2
                   sts ASSR,r16

                   ;************ TIMER_COUNTER_3 ***************
                   ldi r16,$00                   ;ICIE3,OCIE3A,TOIE3
                   sts TIMSK3,r16

                   ldi r16,$00                   ;COM3A1,COM3A0,COM3B1,COM3B0,COM3C1,COM3C0,WGM31,WGM30
                   sts TCCR3A,r16

                   ldi r16,$00                   ;ICNC3,ICES3,WGM33,WGM32,CS32,CS31,CS30
                   sts TCCR3B,r16

                   ldi r16,$00                   ;FOC3A,FOC3B,FOC3C
                   sts TCCR3C,r16

                   ldi r16,High($0000)           ;
                   sts OCR3AH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR3AL,r16

                   ldi r16,High($0000)           ;
                   sts OCR3BH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR3BL,r16

                   ldi r16,High($0000)           ;
                   sts ICR3H,r16

                   ldi r16,Low($0000)            ;
                   sts ICR3L,r16

                   ldi r16,High($0000)           ;
                   sts OCR3CH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR3CL,r16

                   ;************ TIMER_COUNTER_4 ***************
                   ldi r16,$00                   ;ICIE4,OCIE4A,TOIE4
                   sts TIMSK4,r16

                   ldi r16,$00                   ;COM4A1,COM4A0,COM4B1,COM4B0,COM4C1,COM4C0,WGM41,WGM40
                   sts TCCR4A,r16

                   ldi r16,$00                   ;ICNC4,ICES4,WGM43,WGM42,CS42,CS41,CS40
                   sts TCCR4B,r16

                   ldi r16,$00                   ;FOC4A,FOC4B,FOC4C
                   sts TCCR4C,r16

                   ldi r16,High($0000)           ;
                   sts OCR4AH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR4AL,r16

                   ldi r16,High($0000)           ;
                   sts OCR4BH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR4BL,r16

                   ldi r16,High($0000)           ;
                   sts ICR4H,r16

                   ldi r16,Low($0000)            ;
                   sts ICR4L,r16

                   ldi r16,High($0000)           ;
                   sts OCR4CH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR4CL,r16

                   ;************ TIMER_COUNTER_5 ***************
                   ldi r16,$00                   ;ICIE5,OCIE5A,TOIE5
                   sts TIMSK5,r16

                   ldi r16,$00                   ;COM5A1,COM5A0,COM5B1,COM5B0,COM5C1,COM5C0,WGM51,WGM50
                   sts TCCR5A,r16

                   ldi r16,$00                   ;ICNC5,ICES5,WGM53,WGM52,CS52,CS51,CS50
                   sts TCCR5B,r16

                   ldi r16,$00                   ;FOC5A,FOC5B,FOC5C
                   sts TCCR5C,r16

                   ldi r16,High($0000)           ;
                   sts OCR5AH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR5AL,r16

                   ldi r16,High($0000)           ;
                   sts OCR5BH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR5BL,r16

                   ldi r16,High($0000)           ;
                   sts ICR5H,r16

                   ldi r16,$00                   ;
                   sts ICR5L,r16

                   ldi r16,High($0000)           ;
                   sts OCR5CH,r16

                   ldi r16,Low($0000)            ;
                   sts OCR5CL,r16

                   ;************* AD_CONVERTER *****************
                   ldi r16,$00                   ;REFS1,REFS0,ADLAR,MUX4,MUX3,MUX2,MUX1,MUX0
                   sts ADMUX,r16

                   ldi r16,$00                   ;ADEN,ADSC,ADATE,ADIF,ADIE,ADPS2,ADPS1,ADPS0
                   sts ADCSRA,r16

                   ldi r16,$00                   ;ACME,MUX5,ADTS2,ADTS1,ADTS0
                   sts ADCSRB,r16

                   ldi r16,$00                   ;ADC7D,ADC6D,ADC5D,ADC4D,ADC3D,ADC2D,ADC1D,ADC0D
                   sts DIDR0,r16

                   ldi r16,$00                   ;ADC15D,ADC14D,ADC13D,ADC12D,ADC11D,ADC10D,ADC9D,ADC8D
                   sts DIDR2,r16

                   ;*********** ANALOG_COMPARATOR **************
                   ldi r16,$00                   ;ACME
                   sts ADCSRB,r16

                   ldi r16,$00                   ;ACD,ACBG,ACI,ACIE,ACIC,ACIS1,ACIS0
                   out ACSR,r16

                   ldi r16,$00                   ;AIN1D,AIN0D
                   sts DIDR1,r16

                   ;*************** WATCHDOG *******************
                   ldi r16,$00                   ;WDIF,WDIE,WDP3,WDCE,WDE,WDP2,WDP1,WDP0
                   sts WDTCSR,r16

                   ;********** EXTERNAL_INTERRUPT **************
                   ldi r16,$00                   ;ISC31,ISC30,ISC21,ISC20,ISC11,ISC10,ISC01,ISC00
                   sts EICRA,r16

                   ldi r16,$00                   ;ISC71,ISC70,ISC61,ISC60,ISC51,ISC50,ISC41,ISC40
                   sts EICRB,r16

                   ldi r16,$00                   ;INT7,INT6,INT5,INT4,INT3,INT2,INT1,INT0
                   out EIMSK,r16

                   ldi r16,$00                   ;INTF7,INTF6,INTF5,INTF4,INTF3,INTF2,INTF1,INTF0
                   out EIFR,r16

                   ldi r16,$00                   ;PCIE2,PCIE1,PCIE0
                   sts PCICR,r16

                   ldi r16,$00                   ;PCIF2,PCIF1,PCIF0
                   out PCIFR,r16

                   ldi r16,$00                   ;PCINT23,PCINT22,PCINT21,PCINT20,PCINT19,PCINT18,PCINT17,PCINT16
                   sts PCMSK2,r16

                   ldi r16,$00                   ;PCINT15,PCINT14,PCINT13,PCINT12,PCINT11,PCINT10,PCINT9,PCINT8
                   sts PCMSK1,r16

                   ldi r16,$00                   ;PCINT7,PCINT6,PCINT5,PCINT4,PCINT3,PCINT2,PCINT1,PCINT0
                   sts PCMSK0,r16

                   ;****************** CPU *********************
                   ldi r16,$00                   ;JTD,PUD,IVSEL,IVCE
                   out MCUCR,r16

                   ldi r16,$00                   ;CAL7,CAL6,CAL5,CAL4,CAL3,CAL2,CAL1,CAL0
                   sts OSCCAL,r16

                   ldi r16,$00                   ;CPKPCE,CLKPS3,CLKPS2,CLKPS1,CLKPS0
                   sts CLKPR,r16

                   ldi r16,$00                   ;RAMPZ1,RAMPZ0
                   out RAMPZ,r16

                   ;*************** BOOT_LOAD ******************
                   ldi r16,$00                   ;SPMIE,SIGRD,RWWSRE,BLBSET,PGWRT,PGERS,SPMEN
                   out SPMCSR,r16

                   ;***************** JTAG *********************
                   ldi r16,$00                   ;JTD
                   out MCUCR,r16

                   sei


;=================================== Interrupt Handler ===================================
EXT_INT0:          reti                          ; IRQ0 Request
EXT_INT1:          reti                          ; IRQ1 Request
EXT_INT2:          reti                          ; IRQ2 Request
EXT_INT3:          reti                          ; IRQ3 Request
EXT_INT4:          reti                          ; IRQ4 Request
EXT_INT5:          reti                          ; IRQ5 Request
EXT_INT6:          reti                          ; IRQ6 Request
EXT_INT7:          reti                          ; IRQ7 Request
PC_INT0:           reti                          ; Pin Change Interrupt Request 0
PC_INT1:           reti                          ; Pin Change Interrupt Request 1
PC_INT2:           reti                          ; Pin Change Interrupt Request 2
WDT:               reti                          ; Watchdog Time-out Interrupt
TIMER2_COMPA:      reti                          ; Timer2 CompareA
TIMER2_COMPB:      reti                          ; Timer2 CompareB
TIMER2_OVF:        reti                          ; Timer2 Overflow
TIMER1_CAPT:       reti                          ; Timer1 Capture
TIMER1_COMPA:      reti                          ; Timer1 CompareA
TIMER1_COMPB:      reti                          ; Timer1 CompareB
TIMER1_COMPC:      reti                          ; Timer1 CompareC
TIMER1_OVF:        reti                          ; Timer1 Overflow
TIMER0_COMPA:      reti                          ; Timer0 CompareA
TIMER0_COMPB:      reti                          ; Timer0 CompareB
TIMER0_OVF:        reti                          ; Timer0 Overflow
SPI_STC:           reti                          ; SPI Serial Transfer Complete
USART0_RXC:        reti                          ; USART0, Rx Complete
USART0_UDRE:       reti                          ; USART0 Data register Empty
USART0_TXC:        reti                          ; USART0, Tx Complete
ANALOG_COMP:       reti                          ; Analog Comparator
ADC_COMP:          reti                          ; ADC Conversion Complete
EE_READY:          reti                          ; EEPROM Ready
TIMER3_CAPT:       reti                          ; Timer3 Capture
TIMER3_COMPA:      reti                          ; Timer3 CompareA
TIMER3_COMPB:      reti                          ; Timer3 CompareB
TIMER3_COMPC:      reti                          ; Timer3 CompareC
TIMER3_OVF:        reti                          ; Timer3 Overflow
USART1_RXC:        reti                          ; USART1, Rx Complete
USART1_UDRE:       reti                          ; USART1 Data register Empty
USART1_TXC:        reti                          ; USART1, Tx Complete
TWI:               reti                          ; 2-wire Serial Interface
SPM_READY:         reti                          ; Store Program Memory Read
TIMER4_CAPT:       reti                          ; Timer4 Capture
TIMER4_COMPA:      reti                          ; Timer4 CompareA
TIMER4_COMPB:      reti                          ; Timer4 CompareB
TIMER4_COMPC:      reti                          ; Timer4 CompareC
TIMER4_OVF:        reti                          ; Timer4 Overflow
TIMER5_CAPT:       reti                          ; Timer5 Capture
TIMER5_COMPA:      reti                          ; Timer5 CompareA
TIMER5_COMPB:      reti                          ; Timer5 CompareB
TIMER5_COMPC:      reti                          ; Timer5 CompareC
TIMER5_OVF:        reti                          ; Timer5 Overflow
USART2_RXC:        reti                          ; USART2, Rx Complete
USART2_UDRE:       reti                          ; USART2 Data register Empty
USART2_TXC:        reti                          ; USART2, Tx Complete
USART3_RXC:        reti                          ; USART3, Rx Complete
USART3_UDRE:       reti                          ; USART3 Data register Empty
USART3_TXC:        reti                          ; USART3, Tx Complete
;=================================== End of Interrupts ===================================

                 ;  .include "debug.asm"

;====================================== End of File ======================================
